module pwm_ctrl(
	clk,
	rst_n,
	pwm_en,
	duty_ctrl,
	pwm_out);

	//---Ports declearation: generated by Robei---
	input clk;
	input rst_n;
	input pwm_en;
	input [1:0] duty_ctrl;
	output pwm_out;

	wire clk;
	wire rst_n;
	wire pwm_en;
	wire [1:0] duty_ctrl;
	reg pwm_out;

	//----Code starts here: integrated by Robei-----
	parameter  CYCLE = 33_333; //1kHz
	//parameter CYCLE = 33;//for test
	
	reg [15:0] cycle_cnt;
	//PWM
	always @(posedge clk or negedge rst_n) begin
	    if(!rst_n)
	        cycle_cnt <= 1'b0;
	    else if(!pwm_en)
	        cycle_cnt <= 1'b0;
	    else if(cycle_cnt == CYCLE-1'b1)
	        cycle_cnt <= 1'b0;
	    else
	        cycle_cnt <= cycle_cnt + 1'b1;
	end
	
	
	reg	[15:0]	duty;			
	always@(posedge clk or negedge rst_n) begin
		if(!rst_n)
	        duty <= 30000;    //90%	
	    else begin
	        case(duty_ctrl)
				2'b00: duty = 16666 ;   //50%
				2'b01: duty = 19999 ;   //60%
				2'b10: duty = 23333 ;   //70%
				2'b11: duty = 26666 ;   //80%
				default: duty = duty;   
			endcase
		end
	end
	
	//for test
	/*always@(posedge clk or negedge rst_n)begin
		if(!rst_n)
	        duty <= 30;    //90%	
	    else begin
	        case(duty_ctrl)
				2'b00: duty = 16 ;   //50%
				2'b01: duty = 19 ;   //60%
				2'b10: duty = 23 ;   //70%
				2'b11: duty = 26 ;   //80%
				default: duty = duty;   
			endcase
		end
	end*/
	
	
	//PWM
	always @(*) begin
	    if(pwm_en && cycle_cnt <= duty)
	        pwm_out <= 1'b1;
	    else 
	        pwm_out <= 1'b0;
	end
	
	
	
endmodule    //pwm_ctrl

